<?php

namespace App\Jobs;

use App\Project;
use Carbon\Carbon;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class CheckProjectStatusJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $projects = Project::all();
        foreach ($projects as $project)
        {
            if ($project->statut != 'ended')
            {
                if (Carbon::createFromFormat('Y-m-d', explode(' ', $project->end_date)[0])->lt(now()->format('Y-m-d')))
                {
                    $project->update(['statut' => 'late']);

                    $project->save();
                }
            }
        }
    }
}
